package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraftforge.common.crafting.CraftingHelper;
import org.apache.commons.lang3.tuple.Pair;

public class Serializer implements RecipeSerializer<EnchantingRecipe> {
  protected static final Gson GSON = (new GsonBuilder()).create();
  
  public EnchantingRecipe fromJson(ResourceLocation id, JsonObject obj) {
    ItemStack output = CraftingHelper.getItemStack(obj.get("result").getAsJsonObject(), true, true);
    Ingredient input = Ingredient.m_43917_(obj.get("input"));
    Pair<EnchantingStatRegistry.Stats, EnchantingStatRegistry.Stats> requirements = EnchantingRecipe.readStats(id, obj);
    return new EnchantingRecipe(id, output, input, (EnchantingStatRegistry.Stats)requirements.getLeft(), (EnchantingStatRegistry.Stats)requirements.getRight());
  }
  
  public EnchantingRecipe fromNetwork(ResourceLocation id, FriendlyByteBuf buf) {
    ItemStack output = buf.m_130267_();
    Ingredient input = Ingredient.m_43940_(buf);
    EnchantingStatRegistry.Stats stats = EnchantingStatRegistry.Stats.read(buf);
    EnchantingStatRegistry.Stats maxStats = buf.readBoolean() ? EnchantingStatRegistry.Stats.read(buf) : EnchantingRecipe.NO_MAX;
    return new EnchantingRecipe(id, output, input, stats, maxStats);
  }
  
  public void toNetwork(FriendlyByteBuf buf, EnchantingRecipe recipe) {
    buf.m_130055_(recipe.output);
    recipe.input.m_43923_(buf);
    recipe.requirements.write(buf);
    buf.writeBoolean((recipe.maxRequirements != EnchantingRecipe.NO_MAX));
    if (recipe.maxRequirements != EnchantingRecipe.NO_MAX)
      recipe.maxRequirements.write(buf); 
  }
}
